# Author:: Gerhard Spitzlsperger
# EMAIL and WWW:: ruby@gs68.de, www.gs68.de
# Copyright:: Copyright (c) 2003 Gerhard Spitzlsperger. All rights reserved.
# License:: LGPL see file LICENSE.
# Version 0.1

 module GS_Statistics
    def self.append_features(mod)
      unless mod < Enumerable
	raise TypeError, 
	"`#{self}' can't be included non Enumerable (#{mod})"
      end

      super
    end

    def sum
      sum = 0.0
      each{|i| sum += i}
      sum
    end

    def average
      sum/size
    end

    def range
      max - min
    end

    def variance
      sum2 = 0.0
      each{|i| sum2 += i*i}
      sum2/size - average**2
    end

    def standard_deviation
      Math::sqrt(variance)
    end

    def quantile(alpha)
      t = sort
      i1 = round(size*alpha)
      i2 = round(size*(1.0-alpha))
      
      [self[i1], self[i2]]
    end

    alias avg average
    alias std standard_deviation
    alias var variance
end